﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO.Ports;
using System.Threading;
using WiimoteLib;//from wiilib

namespace RobowiiL
{
    public class nxtCommand
    {
        private SerialPort bconn;//serial port number to connect
        private RoboMain roboM;//robot main class developed By 2(G.P.)

        public nxtCommand(SerialPort bconn, RoboMain roboM)
        {
            this.bconn = bconn;
            this.roboM = roboM;
        }


        //NXTSendCommandAndGetReply
        //this function permit to send message and read reply trought bluetooth
        private void NXTSendCommandAndGetReply(byte[] Command)
        {
            Byte[] MessageLength = { 0x00, 0x00 };
            string msg = "";


            MessageLength[0] = (byte)Command.Length;
            msg += "TX:";
            for (int i = 0; i < Command.Length; i++)
                msg += Command[i].ToString("X2") + " ";
            msg += "\n";
            roboM.externwriteOnLog(msg);//log on gui

            bconn.Write(MessageLength, 0, MessageLength.Length);//write on virtual com port
            bconn.Write(Command, 0, Command.Length);


            if (Command[0] == 0x00)//if we wait for reply from NXT
            {
                msg = "";

                int length = bconn.ReadByte() + 256 * bconn.ReadByte();
                msg += "RX:";
                for (int i = 0; i < length; i++)
                    msg += bconn.ReadByte().ToString("X2") + " ";
                msg += "\n";
                roboM.externwriteOnLog(msg);//log on gui

            }
        }



        //******* here start cmd sent to nxt via BT ********

        public void SoundCmd(object sender, EventArgs e)
        {
            byte[] NxtMessage = { 0x00, 0x03, 0x07, 0xda, 0xf0, 0x00 };

            NXTSendCommandAndGetReply(NxtMessage);
        }

        public void MotorACmd()
        {
            byte[] NxtMessage = { 0x00,
                                  0x04, //input command
                                  0x00, //n port, ff all motors
                                  0x64, //power
                                  0x01, //mode
                                  0x00, //regulation
                                  0x10, //turn ratio
                                  0x20, //runstate
                                  0x00, 0x00, 0x00, 0x00 };//angle

            NXTSendCommandAndGetReply(NxtMessage);

        }

        public void breakbtnCmd()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
                                  0x09, //command messagewrite o messageread?!
                                  0x01, //inbox number  (numero arbitrario da 9 a 0)
                                  0x05, //message size
                                  57,   //9
                                  57,   //9
                                  00  };//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }

        public void turnAround()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
                                  0x09, //command messagewrite o messageread?!
                                  0x01, //inbox number  (numero arbitrario da 9 a 0)
                                  0x05, //message size
                                  53,   //5
                                  00  };//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }

        public void turnLeft()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
                                  0x09, //command messagewrite o messageread?!
                                  0x01, //inbox number  (numero arbitrario da 9 a 0)
                                  0x05, //message size
                                  52,   //4
                                  00  };//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }

        public void turnRight()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
                                  0x09, //command messagewrite o messageread?!
                                  0x01, //inbox number  (numero arbitrario da 9 a 0)
                                  0x05, //message size
                                  51,   //3
                                  00  };//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }


        public void forward()
        {
            byte[] NxtMessage = { 0x80, //senza risposta
                                  0x09, //command messagewrite o messageread?!
                                  0x01, //inbox number  (numero arbitrario da 9 a 0)
                                  0x05, //message size
                                  49,   //1
                                  00  };//messagedata

            NXTSendCommandAndGetReply(NxtMessage);

        }

        public void backward()
        {
            //string messageData = "back";
            //back=2
            byte[] NxtMessage = { 0x80, //senza risposta
                                  0x09, //command messagewrite o messageread?!
                                  0x01, //inbox number  (numero arbitrario da 9 a 0)
                                  0x05, //message size
                                  50,   //2
                                  00  };//messagedata
            
            NXTSendCommandAndGetReply(NxtMessage);

        }
        //************************************************************************************
    }
}
